﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NestedExceptionsAndFinally {
	class Program {
		static void Main(string[] args) {
			Console.WriteLine("*** Without rethrow ***");
			try {
				try {
					throw new ArgumentException();
				} finally {
					Console.WriteLine("Finally 1: begin");
					try {
						try {
							throw new IndexOutOfRangeException();
						} finally {
							Console.WriteLine("	Finally 2: begin");
							try {
								try {
									throw new NotSupportedException();
								} finally {
									Console.WriteLine("		Finally 3: here");
								}
							} catch (Exception ex) {
								Console.WriteLine("		Inner catch: {0}", ex.GetType());
								// throw; // No rethrow here.
							}
							Console.WriteLine("	Finally 2: end");
						}
					} catch (Exception ex) {
						Console.WriteLine("	Middle catch: {0}", ex.GetType());
					}
					Console.WriteLine("Finally 1: end");
				}
			} catch (Exception ex) {
				Console.WriteLine("Outer catch: {0}", ex);
			}

			Console.WriteLine();
			Console.Write("Press ENTER to continue with variant with rethrow ...");
			Console.ReadLine();
			//
			// Following code is exactly the same as above, only the throw in inner catch is uncommented.
			//
			Console.WriteLine("*** With rethrow ***");

			try {
				try {
					throw new ArgumentException();
				} finally {
					Console.WriteLine("Finally 1: begin");
					try {
						try {
							throw new IndexOutOfRangeException();
						} finally {
							Console.WriteLine("	Finally 2: begin");
							try {
								try {
									throw new NotSupportedException();
								} finally {
									Console.WriteLine("		Finally 3: here");
								}
							} catch (Exception ex) {
								Console.WriteLine("		Inner catch: {0}", ex.GetType());
								throw;	// Rethrowing
							}
							Console.WriteLine("	Finally 2: end");
						}
					} catch (Exception ex) {
						Console.WriteLine("	Middle catch: {0}", ex.GetType());
					}
					Console.WriteLine("Finally 1: end");
				}
			} catch (Exception ex) {
				Console.WriteLine("Outer catch: {0}", ex);
			}

		}
	}
}
